CREATE DATABASE /*!32312 IF NOT EXISTS*/ aseco;
USE aseco;
CREATE TABLE `challenges` (
  `Id` mediumint(9) NOT NULL auto_increment,
  `Uid` varchar(27) NOT NULL default '',
  `Name` varchar(100) NOT NULL default '',
  `Author` varchar(40) NOT NULL default '',
  `Environment` varchar(15) NOT NULL default '',
  `TMXType` varchar(3) NOT NULL default '',
  `TMXId` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `Uid` (`Uid`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE `mistral_chat` (
  `mid` mediumint(8) unsigned NOT NULL auto_increment,
  `message` varchar(256) NOT NULL,
  PRIMARY KEY  (`mid`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE `players` (
  `Id` mediumint(9) NOT NULL auto_increment,
  `Login` varchar(50) NOT NULL default '',
  `Game` varchar(3) NOT NULL default '',
  `NickName` varchar(80) NOT NULL default '',
  `Nation` varchar(32) NOT NULL default '-',
  `UpdatedAt` datetime NOT NULL default '0000-00-00 00:00:00',
  `Wins` mediumint(9) NOT NULL default '0',
  `TimePlayed` mediumint(9) NOT NULL default '0',
  `TeamName` char(60) default NULL,
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `Login` (`Login`),
  KEY `Game` (`Game`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE `records` (
  `Id` mediumint(9) NOT NULL auto_increment,
  `ChallengeId` mediumint(9) NOT NULL default '0',
  `PlayerId` mediumint(9) NOT NULL default '0',
  `Score` mediumint(9) NOT NULL default '0',
  `Rank` int(10) unsigned NOT NULL default '0',
  `Date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `ChallengeId` (`ChallengeId`,`PlayerId`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE `rs_karma` (
  `Id` int(11) NOT NULL auto_increment,
  `Score` smallint(6) NOT NULL default '0',
  `PlayerId` mediumint(9) NOT NULL default '0',
  `ChallengeId` mediumint(9) NOT NULL default '0',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `PlayerId` (`PlayerId`,`ChallengeId`),
  KEY `ChallengeId` (`ChallengeId`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;

CREATE TABLE `rs_rank` (
  `playerID` mediumint(9) NOT NULL default '0',
  `avg` float NOT NULL default '0',
  KEY `playerID` (`playerID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `votes` (
  `Id` int(11) NOT NULL auto_increment,
  `Score` smallint(6) NOT NULL default '0',
  `PlayerId` mediumint(9) NOT NULL default '0',
  `ChallengeId` mediumint(9) NOT NULL default '0',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `PlayerId` (`PlayerId`,`ChallengeId`),
  KEY `ChallengeId` (`ChallengeId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
